/* pattern.c generated by valac 0.26.1, the Vala compiler
 * generated from pattern.vala, do not modify */

/*
 Copyright (C) 2009-2014 Christian Dywan <christian@twotoasts.de>
 Copyright (C) 2009-2012 Alexander Butenko <a.butenka@gmail.com>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define ADBLOCK_TYPE_FEATURE (adblock_feature_get_type ())
#define ADBLOCK_FEATURE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ADBLOCK_TYPE_FEATURE, AdblockFeature))
#define ADBLOCK_FEATURE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ADBLOCK_TYPE_FEATURE, AdblockFeatureClass))
#define ADBLOCK_IS_FEATURE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ADBLOCK_TYPE_FEATURE))
#define ADBLOCK_IS_FEATURE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ADBLOCK_TYPE_FEATURE))
#define ADBLOCK_FEATURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ADBLOCK_TYPE_FEATURE, AdblockFeatureClass))

typedef struct _AdblockFeature AdblockFeature;
typedef struct _AdblockFeatureClass AdblockFeatureClass;
typedef struct _AdblockFeaturePrivate AdblockFeaturePrivate;

#define ADBLOCK_TYPE_DIRECTIVE (adblock_directive_get_type ())

#define ADBLOCK_TYPE_FILTER (adblock_filter_get_type ())
#define ADBLOCK_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ADBLOCK_TYPE_FILTER, AdblockFilter))
#define ADBLOCK_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ADBLOCK_TYPE_FILTER, AdblockFilterClass))
#define ADBLOCK_IS_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ADBLOCK_TYPE_FILTER))
#define ADBLOCK_IS_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ADBLOCK_TYPE_FILTER))
#define ADBLOCK_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ADBLOCK_TYPE_FILTER, AdblockFilterClass))

typedef struct _AdblockFilter AdblockFilter;
typedef struct _AdblockFilterClass AdblockFilterClass;
typedef struct _AdblockFilterPrivate AdblockFilterPrivate;

#define ADBLOCK_TYPE_PATTERN (adblock_pattern_get_type ())
#define ADBLOCK_PATTERN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ADBLOCK_TYPE_PATTERN, AdblockPattern))
#define ADBLOCK_PATTERN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ADBLOCK_TYPE_PATTERN, AdblockPatternClass))
#define ADBLOCK_IS_PATTERN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ADBLOCK_TYPE_PATTERN))
#define ADBLOCK_IS_PATTERN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ADBLOCK_TYPE_PATTERN))
#define ADBLOCK_PATTERN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ADBLOCK_TYPE_PATTERN, AdblockPatternClass))

typedef struct _AdblockPattern AdblockPattern;
typedef struct _AdblockPatternClass AdblockPatternClass;
typedef struct _AdblockPatternPrivate AdblockPatternPrivate;

#define ADBLOCK_TYPE_OPTIONS (adblock_options_get_type ())
#define ADBLOCK_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ADBLOCK_TYPE_OPTIONS, AdblockOptions))
#define ADBLOCK_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ADBLOCK_TYPE_OPTIONS, AdblockOptionsClass))
#define ADBLOCK_IS_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ADBLOCK_TYPE_OPTIONS))
#define ADBLOCK_IS_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ADBLOCK_TYPE_OPTIONS))
#define ADBLOCK_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ADBLOCK_TYPE_OPTIONS, AdblockOptionsClass))

typedef struct _AdblockOptions AdblockOptions;
typedef struct _AdblockOptionsClass AdblockOptionsClass;
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

typedef enum  {
	ADBLOCK_DIRECTIVE_ALLOW,
	ADBLOCK_DIRECTIVE_BLOCK
} AdblockDirective;

struct _AdblockFeature {
	GObject parent_instance;
	AdblockFeaturePrivate * priv;
};

struct _AdblockFeatureClass {
	GObjectClass parent_class;
	gboolean (*header) (AdblockFeature* self, const gchar* key, const gchar* value);
	gboolean (*parsed) (AdblockFeature* self, GFile* file);
	AdblockDirective* (*match) (AdblockFeature* self, const gchar* request_uri, const gchar* page_uri, GError** error);
	void (*clear) (AdblockFeature* self);
};

struct _AdblockFilter {
	AdblockFeature parent_instance;
	AdblockFilterPrivate * priv;
	GHashTable* rules;
};

struct _AdblockFilterClass {
	AdblockFeatureClass parent_class;
	void (*insert) (AdblockFilter* self, const gchar* sig, GRegex* regex);
	GRegex* (*lookup) (AdblockFilter* self, const gchar* sig);
	guint (*size) (AdblockFilter* self);
};

struct _AdblockPattern {
	AdblockFilter parent_instance;
	AdblockPatternPrivate * priv;
};

struct _AdblockPatternClass {
	AdblockFilterClass parent_class;
};


static gpointer adblock_pattern_parent_class = NULL;

GType adblock_feature_get_type (void) G_GNUC_CONST;
GType adblock_directive_get_type (void) G_GNUC_CONST;
GType adblock_filter_get_type (void) G_GNUC_CONST;
GType adblock_pattern_get_type (void) G_GNUC_CONST;
enum  {
	ADBLOCK_PATTERN_DUMMY_PROPERTY
};
GType adblock_options_get_type (void) G_GNUC_CONST;
AdblockPattern* adblock_pattern_new (AdblockOptions* options);
AdblockPattern* adblock_pattern_construct (GType object_type, AdblockOptions* options);
AdblockFilter* adblock_filter_construct (GType object_type, AdblockOptions* options);
static AdblockDirective* adblock_pattern_real_match (AdblockFeature* base, const gchar* request_uri, const gchar* page_uri, GError** error);
gboolean adblock_filter_check_rule (AdblockFilter* self, GRegex* regex, const gchar* pattern, const gchar* request_uri, const gchar* page_uri, GError** error);
static AdblockDirective* _adblock_directive_dup (AdblockDirective* self);


AdblockPattern* adblock_pattern_construct (GType object_type, AdblockOptions* options) {
	AdblockPattern * self = NULL;
	AdblockOptions* _tmp0_ = NULL;
#line 15 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	g_return_val_if_fail (options != NULL, NULL);
#line 16 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	_tmp0_ = options;
#line 16 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	self = (AdblockPattern*) adblock_filter_construct (object_type, _tmp0_);
#line 15 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	return self;
#line 140 "pattern.c"
}


AdblockPattern* adblock_pattern_new (AdblockOptions* options) {
#line 15 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	return adblock_pattern_construct (ADBLOCK_TYPE_PATTERN, options);
#line 147 "pattern.c"
}


static AdblockDirective* _adblock_directive_dup (AdblockDirective* self) {
	AdblockDirective* dup;
#line 22 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	dup = g_new0 (AdblockDirective, 1);
#line 22 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	memcpy (dup, self, sizeof (AdblockDirective));
#line 22 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	return dup;
#line 159 "pattern.c"
}


static gpointer __adblock_directive_dup0 (gpointer self) {
#line 22 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	return self ? _adblock_directive_dup (self) : NULL;
#line 166 "pattern.c"
}


static AdblockDirective* adblock_pattern_real_match (AdblockFeature* base, const gchar* request_uri, const gchar* page_uri, GError** error) {
	AdblockPattern * self;
	AdblockDirective* result = NULL;
	GHashTable* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 19 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	self = (AdblockPattern*) base;
#line 19 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	g_return_val_if_fail (request_uri != NULL, NULL);
#line 19 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	g_return_val_if_fail (page_uri != NULL, NULL);
#line 20 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	_tmp0_ = ((AdblockFilter*) self)->rules;
#line 20 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
#line 186 "pattern.c"
	{
		GList* patt_collection = NULL;
		GList* patt_it = NULL;
#line 20 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
		patt_collection = _tmp1_;
#line 20 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
		for (patt_it = patt_collection; patt_it != NULL; patt_it = patt_it->next) {
#line 194 "pattern.c"
			const gchar* patt = NULL;
#line 20 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
			patt = (const gchar*) patt_it->data;
#line 198 "pattern.c"
			{
				gboolean _tmp2_ = FALSE;
				GHashTable* _tmp3_ = NULL;
				const gchar* _tmp4_ = NULL;
				gconstpointer _tmp5_ = NULL;
				const gchar* _tmp6_ = NULL;
				const gchar* _tmp7_ = NULL;
				const gchar* _tmp8_ = NULL;
				gboolean _tmp9_ = FALSE;
#line 21 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
				_tmp3_ = ((AdblockFilter*) self)->rules;
#line 21 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
				_tmp4_ = patt;
#line 21 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
				_tmp5_ = g_hash_table_lookup (_tmp3_, _tmp4_);
#line 21 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
				_tmp6_ = patt;
#line 21 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
				_tmp7_ = request_uri;
#line 21 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
				_tmp8_ = page_uri;
#line 21 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
				_tmp9_ = adblock_filter_check_rule ((AdblockFilter*) self, (GRegex*) _tmp5_, _tmp6_, _tmp7_, _tmp8_, &_inner_error_);
#line 21 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
				_tmp2_ = _tmp9_;
#line 21 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 21 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
					g_propagate_error (error, _inner_error_);
#line 21 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
					_g_list_free0 (patt_collection);
#line 21 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
					return NULL;
#line 232 "pattern.c"
				}
#line 21 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
				if (_tmp2_) {
#line 236 "pattern.c"
					AdblockDirective _tmp10_ = 0;
					AdblockDirective* _tmp11_ = NULL;
#line 22 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
					_tmp10_ = ADBLOCK_DIRECTIVE_BLOCK;
#line 22 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
					_tmp11_ = __adblock_directive_dup0 (&_tmp10_);
#line 22 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
					result = _tmp11_;
#line 22 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
					_g_list_free0 (patt_collection);
#line 22 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
					return result;
#line 249 "pattern.c"
				}
			}
		}
#line 20 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
		_g_list_free0 (patt_collection);
#line 255 "pattern.c"
	}
#line 23 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	result = NULL;
#line 23 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	return result;
#line 261 "pattern.c"
}


static void adblock_pattern_class_init (AdblockPatternClass * klass) {
#line 14 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	adblock_pattern_parent_class = g_type_class_peek_parent (klass);
#line 14 "/builddir/build/BUILD/midori-0.5.9/extensions/adblock/pattern.vala"
	((AdblockFeatureClass *) klass)->match = adblock_pattern_real_match;
#line 270 "pattern.c"
}


static void adblock_pattern_instance_init (AdblockPattern * self) {
}


GType adblock_pattern_get_type (void) {
	static volatile gsize adblock_pattern_type_id__volatile = 0;
	if (g_once_init_enter (&adblock_pattern_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AdblockPatternClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) adblock_pattern_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AdblockPattern), 0, (GInstanceInitFunc) adblock_pattern_instance_init, NULL };
		GType adblock_pattern_type_id;
		adblock_pattern_type_id = g_type_register_static (ADBLOCK_TYPE_FILTER, "AdblockPattern", &g_define_type_info, 0);
		g_once_init_leave (&adblock_pattern_type_id__volatile, adblock_pattern_type_id);
	}
	return adblock_pattern_type_id__volatile;
}



