/* midori-database.c generated by valac 0.26.1, the Vala compiler
 * generated from midori-database.vala, do not modify */

/*
 Copyright (C) 2013 Christian Dywan <christian@twotoats.de>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <sqlite3.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <float.h>
#include <math.h>
#include <unistd.h>
#include <glib/gstdio.h>


#define MIDORI_TYPE_DATABASE_STATEMENT (midori_database_statement_get_type ())
#define MIDORI_DATABASE_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MIDORI_TYPE_DATABASE_STATEMENT, MidoriDatabaseStatement))
#define MIDORI_DATABASE_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MIDORI_TYPE_DATABASE_STATEMENT, MidoriDatabaseStatementClass))
#define MIDORI_IS_DATABASE_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MIDORI_TYPE_DATABASE_STATEMENT))
#define MIDORI_IS_DATABASE_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MIDORI_TYPE_DATABASE_STATEMENT))
#define MIDORI_DATABASE_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MIDORI_TYPE_DATABASE_STATEMENT, MidoriDatabaseStatementClass))

typedef struct _MidoriDatabaseStatement MidoriDatabaseStatement;
typedef struct _MidoriDatabaseStatementClass MidoriDatabaseStatementClass;
typedef struct _MidoriDatabaseStatementPrivate MidoriDatabaseStatementPrivate;

#define MIDORI_TYPE_DATABASE (midori_database_get_type ())
#define MIDORI_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MIDORI_TYPE_DATABASE, MidoriDatabase))
#define MIDORI_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MIDORI_TYPE_DATABASE, MidoriDatabaseClass))
#define MIDORI_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MIDORI_TYPE_DATABASE))
#define MIDORI_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MIDORI_TYPE_DATABASE))
#define MIDORI_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MIDORI_TYPE_DATABASE, MidoriDatabaseClass))

typedef struct _MidoriDatabase MidoriDatabase;
typedef struct _MidoriDatabaseClass MidoriDatabaseClass;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MidoriDatabasePrivate MidoriDatabasePrivate;
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block2Data Block2Data;

typedef enum  {
	MIDORI_DATABASE_ERROR_OPEN,
	MIDORI_DATABASE_ERROR_NAMING,
	MIDORI_DATABASE_ERROR_FILENAME,
	MIDORI_DATABASE_ERROR_EXECUTE,
	MIDORI_DATABASE_ERROR_COMPILE,
	MIDORI_DATABASE_ERROR_TYPE
} MidoriDatabaseError;
#define MIDORI_DATABASE_ERROR midori_database_error_quark ()
typedef gboolean (*MidoriDatabaseCallback) (void* user_data, GError** error);
struct _MidoriDatabaseStatement {
	GObject parent_instance;
	MidoriDatabaseStatementPrivate * priv;
	sqlite3_stmt* _stmt;
};

struct _MidoriDatabaseStatementClass {
	GObjectClass parent_class;
	gboolean (*init) (MidoriDatabaseStatement* self, GCancellable* cancellable, GError** error);
};

struct _MidoriDatabaseStatementPrivate {
	MidoriDatabase* _database;
	gchar* _query;
	gint64 last_row_id;
};

struct _MidoriDatabase {
	GObject parent_instance;
	MidoriDatabasePrivate * priv;
	gboolean trace;
	sqlite3* _db;
};

struct _MidoriDatabaseClass {
	GObjectClass parent_class;
	gboolean (*init) (MidoriDatabase* self, GCancellable* cancellable, GError** error);
};

struct _MidoriDatabasePrivate {
	gchar* _path;
	gboolean _first_use;
};

struct _Block2Data {
	int _ref_count_;
	MidoriDatabase* self;
	gchar* schema;
};


static gpointer midori_database_statement_parent_class = NULL;
static GInitableIface* midori_database_statement_g_initable_parent_iface = NULL;
static gpointer midori_database_parent_class = NULL;
static GInitableIface* midori_database_g_initable_parent_iface = NULL;

GQuark midori_database_error_quark (void);
GType midori_database_statement_get_type (void) G_GNUC_CONST;
GType midori_database_get_type (void) G_GNUC_CONST;
#define MIDORI_DATABASE_STATEMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MIDORI_TYPE_DATABASE_STATEMENT, MidoriDatabaseStatementPrivate))
enum  {
	MIDORI_DATABASE_STATEMENT_DUMMY_PROPERTY,
	MIDORI_DATABASE_STATEMENT_STMT,
	MIDORI_DATABASE_STATEMENT_DATABASE,
	MIDORI_DATABASE_STATEMENT_QUERY
};
MidoriDatabaseStatement* midori_database_statement_new (MidoriDatabase* database, const gchar* query, GError** error);
MidoriDatabaseStatement* midori_database_statement_construct (GType object_type, MidoriDatabase* database, const gchar* query, GError** error);
gboolean midori_database_statement_init (MidoriDatabaseStatement* self, GCancellable* cancellable, GError** error);
static gboolean midori_database_statement_real_init (MidoriDatabaseStatement* self, GCancellable* cancellable, GError** error);
MidoriDatabase* midori_database_statement_get_database (MidoriDatabaseStatement* self);
sqlite3* midori_database_get_db (MidoriDatabase* self);
const gchar* midori_database_statement_get_query (MidoriDatabaseStatement* self);
void midori_database_statement_bind (MidoriDatabaseStatement* self, const gchar* pname, GError** error, ...);
sqlite3_stmt* midori_database_statement_get_stmt (MidoriDatabaseStatement* self);
gboolean midori_database_statement_exec (MidoriDatabaseStatement* self, GError** error);
gboolean midori_database_statement_step (MidoriDatabaseStatement* self, GError** error);
gint64 midori_database_statement_row_id (MidoriDatabaseStatement* self, GError** error);
static gint midori_database_statement_column_index (MidoriDatabaseStatement* self, const gchar* name, GError** error);
gchar* midori_database_statement_get_string (MidoriDatabaseStatement* self, const gchar* name, GError** error);
gint64 midori_database_statement_get_int64 (MidoriDatabaseStatement* self, const gchar* name, GError** error);
gdouble midori_database_statement_get_double (MidoriDatabaseStatement* self, const gchar* name, GError** error);
void midori_database_statement_set_database (MidoriDatabaseStatement* self, MidoriDatabase* value);
void midori_database_statement_set_query (MidoriDatabaseStatement* self, const gchar* value);
static void midori_database_statement_finalize (GObject* obj);
static void _vala_midori_database_statement_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_midori_database_statement_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define MIDORI_DATABASE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MIDORI_TYPE_DATABASE, MidoriDatabasePrivate))
enum  {
	MIDORI_DATABASE_DUMMY_PROPERTY,
	MIDORI_DATABASE_DB,
	MIDORI_DATABASE_PATH,
	MIDORI_DATABASE_FIRST_USE
};
MidoriDatabase* midori_database_new (const gchar* path, GError** error);
MidoriDatabase* midori_database_construct (GType object_type, const gchar* path, GError** error);
gboolean midori_database_init (MidoriDatabase* self, GCancellable* cancellable, GError** error);
static gchar* midori_database_resolve_path (MidoriDatabase* self, const gchar* path);
gchar* midori_paths_get_config_filename_for_writing (const gchar* filename);
static gboolean midori_database_real_init (MidoriDatabase* self, GCancellable* cancellable, GError** error);
const gchar* midori_database_get_path (MidoriDatabase* self);
static void ___lambda9_ (MidoriDatabase* self, const gchar* sql, guint64 nanoseconds);
static void ____lambda9__sqlite_profile_callback (gpointer self, const gchar* sql, guint64 time);
gboolean midori_database_exec_script (MidoriDatabase* self, const gchar* filename, GError** error);
gboolean midori_database_exec (MidoriDatabase* self, const gchar* query, GError** error);
void midori_database_set_first_use (MidoriDatabase* self, gboolean value);
gboolean midori_database_attach (MidoriDatabase* self, const gchar* path, const gchar* alias, GError** error);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
gchar* midori_paths_get_res_filename (const gchar* filename);
gboolean midori_database_transaction (MidoriDatabase* self, MidoriDatabaseCallback callback, void* callback_target, GError** error);
static gboolean __lambda10_ (Block2Data* _data2_, GError** error);
static gboolean ___lambda10__midori_database_callback (gpointer self, GError** error);
MidoriDatabaseStatement* midori_database_prepare (MidoriDatabase* self, const gchar* query, GError** error, ...);
void midori_database_set_path (MidoriDatabase* self, const gchar* value);
gboolean midori_database_get_first_use (MidoriDatabase* self);
static void midori_database_finalize (GObject* obj);
static void _vala_midori_database_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_midori_database_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GQuark midori_database_error_quark (void) {
	return g_quark_from_static_string ("midori_database_error-quark");
}


MidoriDatabaseStatement* midori_database_statement_construct (GType object_type, MidoriDatabase* database, const gchar* query, GError** error) {
	MidoriDatabaseStatement * self = NULL;
	MidoriDatabase* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 40 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (database != NULL, NULL);
#line 40 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (query != NULL, NULL);
#line 41 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = database;
#line 41 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = query;
#line 41 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self = (MidoriDatabaseStatement*) g_object_new (object_type, "database", _tmp0_, "query", _tmp1_, NULL);
#line 42 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	midori_database_statement_init (self, NULL, &_inner_error_);
#line 42 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 42 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 42 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 42 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_object_unref0 (self);
#line 42 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return NULL;
#line 214 "midori-database.c"
		} else {
#line 42 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 42 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 42 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return NULL;
#line 222 "midori-database.c"
		}
	}
#line 40 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return self;
#line 227 "midori-database.c"
}


MidoriDatabaseStatement* midori_database_statement_new (MidoriDatabase* database, const gchar* query, GError** error) {
#line 40 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return midori_database_statement_construct (MIDORI_TYPE_DATABASE_STATEMENT, database, query, error);
#line 234 "midori-database.c"
}


static gboolean midori_database_statement_real_init (MidoriDatabaseStatement* self, GCancellable* cancellable, GError** error) {
	gboolean result = FALSE;
	gint _result_ = 0;
	MidoriDatabase* _tmp0_ = NULL;
	sqlite3* _tmp1_ = NULL;
	sqlite3* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GError * _inner_error_ = NULL;
#line 46 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = self->priv->_database;
#line 46 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = midori_database_get_db (_tmp0_);
#line 46 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp2_ = _tmp1_;
#line 46 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp3_ = self->priv->_query;
#line 46 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp2_, _tmp3_, -1, &_tmp4_, NULL);
#line 46 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_sqlite3_finalize0 (self->_stmt);
#line 46 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->_stmt = _tmp4_;
#line 46 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_result_ = _tmp5_;
#line 47 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp6_ = _result_;
#line 47 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp6_ != SQLITE_OK) {
#line 269 "midori-database.c"
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		GError* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
#line 48 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp7_ = self->priv->_query;
#line 48 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp8_ = g_strdup_printf ("Failed to compile statement: %s", _tmp7_);
#line 48 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp9_ = _tmp8_;
#line 48 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp10_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_COMPILE, _tmp9_);
#line 48 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp11_ = _tmp10_;
#line 48 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_tmp9_);
#line 48 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = _tmp11_;
#line 48 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 48 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 48 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 295 "midori-database.c"
		} else {
#line 48 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 48 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 48 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 303 "midori-database.c"
		}
	}
#line 49 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = TRUE;
#line 49 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 310 "midori-database.c"
}


gboolean midori_database_statement_init (MidoriDatabaseStatement* self, GCancellable* cancellable, GError** error) {
#line 45 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return MIDORI_DATABASE_STATEMENT_GET_CLASS (self)->init (self, cancellable, error);
#line 319 "midori-database.c"
}


static gchar* double_to_string (gdouble self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
#line 783 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 783 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 783 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 783 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
#line 783 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 783 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 783 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 783 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 783 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	return result;
#line 349 "midori-database.c"
}


void midori_database_statement_bind (MidoriDatabaseStatement* self, const gchar* pname, GError** error, ...) {
	gint pindex = 0;
	sqlite3_stmt* _tmp0_ = NULL;
	sqlite3_stmt* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	va_list args = {0};
	GType ptype = 0UL;
	GType _tmp4_ = 0UL;
	GType _tmp5_ = 0UL;
	GError * _inner_error_ = NULL;
#line 58 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_if_fail (self != NULL);
#line 58 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_if_fail (pname != NULL);
#line 59 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = midori_database_statement_get_stmt (self);
#line 59 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = _tmp0_;
#line 59 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp2_ = pname;
#line 59 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp3_ = sqlite3_bind_parameter_index (_tmp1_, _tmp2_);
#line 59 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	pindex = _tmp3_;
#line 60 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	va_start (args, error);
#line 61 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp4_ = va_arg (args, GType);
#line 61 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	ptype = _tmp4_;
#line 62 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp5_ = ptype;
#line 62 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp5_ == G_TYPE_STRING) {
#line 388 "midori-database.c"
		gchar* text = NULL;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		sqlite3_stmt* _tmp8_ = NULL;
		sqlite3_stmt* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		GDestroyNotify _tmp13_ = NULL;
		MidoriDatabase* _tmp14_ = NULL;
		gboolean _tmp15_ = FALSE;
#line 63 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp6_ = va_arg (args, gchar*);
#line 63 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 63 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		text = _tmp7_;
#line 64 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp8_ = midori_database_statement_get_stmt (self);
#line 64 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp9_ = _tmp8_;
#line 64 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp10_ = pindex;
#line 64 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp11_ = text;
#line 64 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 64 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp13_ = g_free;
#line 64 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		sqlite3_bind_text (_tmp9_, _tmp10_, _tmp12_, -1, _tmp13_);
#line 65 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp14_ = self->priv->_database;
#line 65 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp15_ = _tmp14_->trace;
#line 65 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_tmp15_) {
#line 426 "midori-database.c"
			FILE* _tmp16_ = NULL;
			const gchar* _tmp17_ = NULL;
			const gchar* _tmp18_ = NULL;
#line 66 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp16_ = stdout;
#line 66 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp17_ = pname;
#line 66 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp18_ = text;
#line 66 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			fprintf (_tmp16_, "%s=%s ", _tmp17_, _tmp18_);
#line 438 "midori-database.c"
		}
#line 62 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (text);
#line 442 "midori-database.c"
	} else {
		GType _tmp19_ = 0UL;
#line 67 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp19_ = ptype;
#line 67 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_tmp19_ == G_TYPE_INT64) {
#line 449 "midori-database.c"
			gint64 integer = 0LL;
			gint64 _tmp20_ = 0LL;
			sqlite3_stmt* _tmp21_ = NULL;
			sqlite3_stmt* _tmp22_ = NULL;
			gint _tmp23_ = 0;
			gint64 _tmp24_ = 0LL;
			MidoriDatabase* _tmp25_ = NULL;
			gboolean _tmp26_ = FALSE;
#line 68 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp20_ = va_arg (args, gint64);
#line 68 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			integer = _tmp20_;
#line 69 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp21_ = midori_database_statement_get_stmt (self);
#line 69 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp22_ = _tmp21_;
#line 69 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp23_ = pindex;
#line 69 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp24_ = integer;
#line 69 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			sqlite3_bind_int64 (_tmp22_, _tmp23_, _tmp24_);
#line 70 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp25_ = self->priv->_database;
#line 70 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp26_ = _tmp25_->trace;
#line 70 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			if (_tmp26_) {
#line 478 "midori-database.c"
				FILE* _tmp27_ = NULL;
				const gchar* _tmp28_ = NULL;
				gint64 _tmp29_ = 0LL;
				gchar* _tmp30_ = NULL;
				gchar* _tmp31_ = NULL;
#line 71 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp27_ = stdout;
#line 71 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp28_ = pname;
#line 71 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp29_ = integer;
#line 71 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp30_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp29_);
#line 71 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp31_ = _tmp30_;
#line 71 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				fprintf (_tmp27_, "%s=%s ", _tmp28_, _tmp31_);
#line 71 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (_tmp31_);
#line 498 "midori-database.c"
			}
		} else {
			GType _tmp32_ = 0UL;
#line 72 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp32_ = ptype;
#line 72 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			if (_tmp32_ == G_TYPE_DOUBLE) {
#line 506 "midori-database.c"
				gdouble stuntman = 0.0;
				gdouble _tmp33_ = 0.0;
				sqlite3_stmt* _tmp34_ = NULL;
				sqlite3_stmt* _tmp35_ = NULL;
				gint _tmp36_ = 0;
				gdouble _tmp37_ = 0.0;
				MidoriDatabase* _tmp38_ = NULL;
				gboolean _tmp39_ = FALSE;
#line 73 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp33_ = va_arg (args, gdouble);
#line 73 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				stuntman = _tmp33_;
#line 74 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp34_ = midori_database_statement_get_stmt (self);
#line 74 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp35_ = _tmp34_;
#line 74 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp36_ = pindex;
#line 74 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp37_ = stuntman;
#line 74 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				sqlite3_bind_double (_tmp35_, _tmp36_, _tmp37_);
#line 75 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp38_ = self->priv->_database;
#line 75 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp39_ = _tmp38_->trace;
#line 75 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				if (_tmp39_) {
#line 535 "midori-database.c"
					FILE* _tmp40_ = NULL;
					const gchar* _tmp41_ = NULL;
					gdouble _tmp42_ = 0.0;
					gchar* _tmp43_ = NULL;
					gchar* _tmp44_ = NULL;
#line 76 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp40_ = stdout;
#line 76 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp41_ = pname;
#line 76 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp42_ = stuntman;
#line 76 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp43_ = double_to_string (_tmp42_);
#line 76 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp44_ = _tmp43_;
#line 76 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					fprintf (_tmp40_, "%s=%s ", _tmp41_, _tmp44_);
#line 76 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_g_free0 (_tmp44_);
#line 555 "midori-database.c"
				}
			} else {
				GType _tmp45_ = 0UL;
				const gchar* _tmp46_ = NULL;
				const gchar* _tmp47_ = NULL;
				const gchar* _tmp48_ = NULL;
				gchar* _tmp49_ = NULL;
				gchar* _tmp50_ = NULL;
				GError* _tmp51_ = NULL;
				GError* _tmp52_ = NULL;
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp45_ = ptype;
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp46_ = g_type_name (_tmp45_);
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp47_ = pname;
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp48_ = self->priv->_query;
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp49_ = g_strdup_printf ("Invalid type '%s' for '%s' in statement: %s", _tmp46_, _tmp47_, _tmp48_);
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp50_ = _tmp49_;
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp51_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_TYPE, _tmp50_);
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp52_ = _tmp51_;
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (_tmp50_);
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_inner_error_ = _tmp52_;
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					g_propagate_error (error, _inner_error_);
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					va_end (args);
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					return;
#line 594 "midori-database.c"
				} else {
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					va_end (args);
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					g_clear_error (&_inner_error_);
#line 78 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					return;
#line 604 "midori-database.c"
				}
			}
		}
	}
#line 58 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	va_end (args);
#line 611 "midori-database.c"
}


gboolean midori_database_statement_exec (MidoriDatabaseStatement* self, GError** error) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 84 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 85 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = midori_database_statement_step (self, &_inner_error_);
#line 85 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = _tmp1_;
#line 85 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 85 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 85 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 85 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 634 "midori-database.c"
		} else {
#line 85 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 85 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 85 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 642 "midori-database.c"
		}
	}
#line 85 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp0_) {
#line 647 "midori-database.c"
		GError* _tmp2_ = NULL;
#line 86 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp2_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, "More rows available - use step instead of exec");
#line 86 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = _tmp2_;
#line 86 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 86 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 86 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 659 "midori-database.c"
		} else {
#line 86 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 86 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 86 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 667 "midori-database.c"
		}
	}
#line 87 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = TRUE;
#line 87 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 674 "midori-database.c"
}


gboolean midori_database_statement_step (MidoriDatabaseStatement* self, GError** error) {
	gboolean result = FALSE;
	gint _result_ = 0;
	sqlite3_stmt* _tmp0_ = NULL;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_ = 0;
	MidoriDatabase* _tmp11_ = NULL;
	sqlite3* _tmp12_ = NULL;
	sqlite3* _tmp13_ = NULL;
	gint64 _tmp14_ = 0LL;
	gint _tmp15_ = 0;
	GError * _inner_error_ = NULL;
#line 93 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 94 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = midori_database_statement_get_stmt (self);
#line 94 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = _tmp0_;
#line 94 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp2_ = sqlite3_step (_tmp1_);
#line 94 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_result_ = _tmp2_;
#line 95 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp4_ = _result_;
#line 95 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp4_ != SQLITE_DONE) {
#line 706 "midori-database.c"
		gint _tmp5_ = 0;
#line 95 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp5_ = _result_;
#line 95 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp3_ = _tmp5_ != SQLITE_ROW;
#line 712 "midori-database.c"
	} else {
#line 95 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp3_ = FALSE;
#line 716 "midori-database.c"
	}
#line 95 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp3_) {
#line 720 "midori-database.c"
		MidoriDatabase* _tmp6_ = NULL;
		sqlite3* _tmp7_ = NULL;
		sqlite3* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		GError* _tmp10_ = NULL;
#line 96 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp6_ = self->priv->_database;
#line 96 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp7_ = midori_database_get_db (_tmp6_);
#line 96 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp8_ = _tmp7_;
#line 96 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp9_ = sqlite3_errmsg (_tmp8_);
#line 96 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp10_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, _tmp9_);
#line 96 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = _tmp10_;
#line 96 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 96 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 96 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 744 "midori-database.c"
		} else {
#line 96 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 96 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 96 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 752 "midori-database.c"
		}
	}
#line 97 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp11_ = self->priv->_database;
#line 97 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp12_ = midori_database_get_db (_tmp11_);
#line 97 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp13_ = _tmp12_;
#line 97 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp14_ = sqlite3_last_insert_rowid (_tmp13_);
#line 97 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->priv->last_row_id = _tmp14_;
#line 98 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp15_ = _result_;
#line 98 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = _tmp15_ == SQLITE_ROW;
#line 98 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 771 "midori-database.c"
}


gint64 midori_database_statement_row_id (MidoriDatabaseStatement* self, GError** error) {
	gint64 result = 0LL;
	gint64 _tmp0_ = 0LL;
	gint64 _tmp2_ = 0LL;
	GError * _inner_error_ = NULL;
#line 106 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 107 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = self->priv->last_row_id;
#line 107 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp0_ == ((gint64) (-1))) {
#line 786 "midori-database.c"
		GError* _tmp1_ = NULL;
#line 108 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp1_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, "No row id");
#line 108 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = _tmp1_;
#line 108 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 108 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 108 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return 0LL;
#line 798 "midori-database.c"
		} else {
#line 108 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 108 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 108 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return 0LL;
#line 806 "midori-database.c"
		}
	}
#line 109 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp2_ = self->priv->last_row_id;
#line 109 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = _tmp2_;
#line 109 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 815 "midori-database.c"
}


static gint midori_database_statement_column_index (MidoriDatabaseStatement* self, const gchar* name, GError** error) {
	gint result = 0;
	const gchar* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	GError* _tmp15_ = NULL;
	GError* _tmp16_ = NULL;
	GError * _inner_error_ = NULL;
#line 112 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 112 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (name != NULL, 0);
#line 832 "midori-database.c"
	{
		gint i = 0;
#line 113 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		i = 0;
#line 837 "midori-database.c"
		{
			gboolean _tmp0_ = FALSE;
#line 113 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp0_ = TRUE;
#line 113 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			while (TRUE) {
#line 844 "midori-database.c"
				gint _tmp2_ = 0;
				sqlite3_stmt* _tmp3_ = NULL;
				sqlite3_stmt* _tmp4_ = NULL;
				gint _tmp5_ = 0;
				const gchar* _tmp6_ = NULL;
				sqlite3_stmt* _tmp7_ = NULL;
				sqlite3_stmt* _tmp8_ = NULL;
				gint _tmp9_ = 0;
				const gchar* _tmp10_ = NULL;
#line 113 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				if (!_tmp0_) {
#line 856 "midori-database.c"
					gint _tmp1_ = 0;
#line 113 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp1_ = i;
#line 113 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					i = _tmp1_ + 1;
#line 862 "midori-database.c"
				}
#line 113 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp0_ = FALSE;
#line 113 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp2_ = i;
#line 113 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp3_ = midori_database_statement_get_stmt (self);
#line 113 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp4_ = _tmp3_;
#line 113 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp5_ = sqlite3_column_count (_tmp4_);
#line 113 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				if (!(_tmp2_ < _tmp5_)) {
#line 113 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					break;
#line 878 "midori-database.c"
				}
#line 114 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp6_ = name;
#line 114 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp7_ = midori_database_statement_get_stmt (self);
#line 114 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp8_ = _tmp7_;
#line 114 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp9_ = i;
#line 114 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp10_ = sqlite3_column_name (_tmp8_, _tmp9_);
#line 114 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				if (g_strcmp0 (_tmp6_, _tmp10_) == 0) {
#line 115 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					result = i;
#line 115 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					return result;
#line 896 "midori-database.c"
				}
			}
		}
	}
#line 117 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp11_ = name;
#line 117 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp12_ = self->priv->_query;
#line 117 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp13_ = g_strdup_printf ("No such column '%s' in row: %s", _tmp11_, _tmp12_);
#line 117 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp14_ = _tmp13_;
#line 117 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp15_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_TYPE, _tmp14_);
#line 117 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp16_ = _tmp15_;
#line 117 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (_tmp14_);
#line 117 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_inner_error_ = _tmp16_;
#line 117 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 117 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		g_propagate_error (error, _inner_error_);
#line 117 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		return 0;
#line 923 "midori-database.c"
	} else {
#line 117 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 117 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		g_clear_error (&_inner_error_);
#line 117 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		return 0;
#line 931 "midori-database.c"
	}
}


gchar* midori_database_statement_get_string (MidoriDatabaseStatement* self, const gchar* name, GError** error) {
	gchar* result = NULL;
	gint index = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint type = 0;
	sqlite3_stmt* _tmp2_ = NULL;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
	sqlite3_stmt* _tmp7_ = NULL;
	sqlite3_stmt* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	sqlite3_stmt* _tmp18_ = NULL;
	sqlite3_stmt* _tmp19_ = NULL;
	gint _tmp20_ = 0;
	const gchar* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	GError * _inner_error_ = NULL;
#line 123 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 123 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 124 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = name;
#line 124 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = midori_database_statement_column_index (self, _tmp0_, &_inner_error_);
#line 124 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	index = _tmp1_;
#line 124 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 124 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 124 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 124 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return NULL;
#line 975 "midori-database.c"
		} else {
#line 124 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 124 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 124 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return NULL;
#line 983 "midori-database.c"
		}
	}
#line 125 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp2_ = midori_database_statement_get_stmt (self);
#line 125 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp3_ = _tmp2_;
#line 125 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp4_ = index;
#line 125 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp5_ = sqlite3_column_type (_tmp3_, _tmp4_);
#line 125 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	type = _tmp5_;
#line 126 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp7_ = midori_database_statement_get_stmt (self);
#line 126 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp8_ = _tmp7_;
#line 126 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp9_ = index;
#line 126 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp10_ = sqlite3_column_type (_tmp8_, _tmp9_);
#line 126 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp10_ != SQLITE3_TEXT) {
#line 1006 "midori-database.c"
		gint _tmp11_ = 0;
#line 126 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp11_ = type;
#line 126 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp6_ = _tmp11_ != SQLITE_NULL;
#line 1012 "midori-database.c"
	} else {
#line 126 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp6_ = FALSE;
#line 1016 "midori-database.c"
	}
#line 126 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp6_) {
#line 1020 "midori-database.c"
		const gchar* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		GError* _tmp16_ = NULL;
		GError* _tmp17_ = NULL;
#line 127 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp12_ = name;
#line 127 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp13_ = self->priv->_query;
#line 127 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp14_ = g_strdup_printf ("Getting '%s' with wrong type in row: %s", _tmp12_, _tmp13_);
#line 127 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp15_ = _tmp14_;
#line 127 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp16_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_TYPE, _tmp15_);
#line 127 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp17_ = _tmp16_;
#line 127 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_tmp15_);
#line 127 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = _tmp17_;
#line 127 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 127 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 127 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return NULL;
#line 1049 "midori-database.c"
		} else {
#line 127 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 127 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 127 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return NULL;
#line 1057 "midori-database.c"
		}
	}
#line 128 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp18_ = midori_database_statement_get_stmt (self);
#line 128 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp19_ = _tmp18_;
#line 128 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp20_ = index;
#line 128 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp21_ = sqlite3_column_text (_tmp19_, _tmp20_);
#line 128 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp22_ = g_strdup (_tmp21_);
#line 128 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = _tmp22_;
#line 128 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 1074 "midori-database.c"
}


gint64 midori_database_statement_get_int64 (MidoriDatabaseStatement* self, const gchar* name, GError** error) {
	gint64 result = 0LL;
	gint index = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint type = 0;
	sqlite3_stmt* _tmp2_ = NULL;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
	gint _tmp7_ = 0;
	sqlite3_stmt* _tmp20_ = NULL;
	sqlite3_stmt* _tmp21_ = NULL;
	gint _tmp22_ = 0;
	gint64 _tmp23_ = 0LL;
	GError * _inner_error_ = NULL;
#line 134 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 134 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (name != NULL, 0LL);
#line 135 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = name;
#line 135 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = midori_database_statement_column_index (self, _tmp0_, &_inner_error_);
#line 135 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	index = _tmp1_;
#line 135 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 135 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 135 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 135 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return 0LL;
#line 1113 "midori-database.c"
		} else {
#line 135 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 135 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 135 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return 0LL;
#line 1121 "midori-database.c"
		}
	}
#line 136 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp2_ = midori_database_statement_get_stmt (self);
#line 136 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp3_ = _tmp2_;
#line 136 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp4_ = index;
#line 136 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp5_ = sqlite3_column_type (_tmp3_, _tmp4_);
#line 136 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	type = _tmp5_;
#line 137 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp7_ = type;
#line 137 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp7_ != SQLITE_INTEGER) {
#line 1138 "midori-database.c"
		gint _tmp8_ = 0;
#line 137 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp8_ = type;
#line 137 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp6_ = _tmp8_ != SQLITE_NULL;
#line 1144 "midori-database.c"
	} else {
#line 137 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp6_ = FALSE;
#line 1148 "midori-database.c"
	}
#line 137 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp6_) {
#line 1152 "midori-database.c"
		const gchar* _tmp9_ = NULL;
		sqlite3_stmt* _tmp10_ = NULL;
		sqlite3_stmt* _tmp11_ = NULL;
		gint _tmp12_ = 0;
		const gchar* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		const gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		GError* _tmp18_ = NULL;
		GError* _tmp19_ = NULL;
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp9_ = name;
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp10_ = midori_database_statement_get_stmt (self);
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp11_ = _tmp10_;
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp12_ = index;
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp13_ = sqlite3_column_text (_tmp11_, _tmp12_);
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp14_ = type;
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp15_ = self->priv->_query;
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp16_ = g_strdup_printf ("Getting '%s' with value '%s' of wrong type %d in row: %s", _tmp9_, _tmp13_, _tmp14_, _tmp15_);
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp17_ = _tmp16_;
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp18_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_TYPE, _tmp17_);
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp19_ = _tmp18_;
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_tmp17_);
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = _tmp19_;
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return 0LL;
#line 1196 "midori-database.c"
		} else {
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 138 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return 0LL;
#line 1204 "midori-database.c"
		}
	}
#line 140 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp20_ = midori_database_statement_get_stmt (self);
#line 140 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp21_ = _tmp20_;
#line 140 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp22_ = index;
#line 140 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp23_ = sqlite3_column_int64 (_tmp21_, _tmp22_);
#line 140 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = _tmp23_;
#line 140 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 1219 "midori-database.c"
}


gdouble midori_database_statement_get_double (MidoriDatabaseStatement* self, const gchar* name, GError** error) {
	gdouble result = 0.0;
	gint index = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	sqlite3_stmt* _tmp2_ = NULL;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	sqlite3_stmt* _tmp12_ = NULL;
	sqlite3_stmt* _tmp13_ = NULL;
	gint _tmp14_ = 0;
	gdouble _tmp15_ = 0.0;
	GError * _inner_error_ = NULL;
#line 146 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 146 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (name != NULL, 0.0);
#line 147 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = name;
#line 147 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = midori_database_statement_column_index (self, _tmp0_, &_inner_error_);
#line 147 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	index = _tmp1_;
#line 147 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 147 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 147 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 147 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return 0.0;
#line 1255 "midori-database.c"
		} else {
#line 147 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 147 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 147 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return 0.0;
#line 1263 "midori-database.c"
		}
	}
#line 148 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp2_ = midori_database_statement_get_stmt (self);
#line 148 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp3_ = _tmp2_;
#line 148 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp4_ = index;
#line 148 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp5_ = sqlite3_column_type (_tmp3_, _tmp4_);
#line 148 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp5_ != SQLITE_FLOAT) {
#line 1276 "midori-database.c"
		const gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		GError* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
#line 149 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp6_ = name;
#line 149 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp7_ = self->priv->_query;
#line 149 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp8_ = g_strdup_printf ("Getting '%s' with wrong type in row: %s", _tmp6_, _tmp7_);
#line 149 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp9_ = _tmp8_;
#line 149 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp10_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_TYPE, _tmp9_);
#line 149 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp11_ = _tmp10_;
#line 149 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_tmp9_);
#line 149 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = _tmp11_;
#line 149 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 149 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 149 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return 0.0;
#line 1305 "midori-database.c"
		} else {
#line 149 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 149 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 149 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return 0.0;
#line 1313 "midori-database.c"
		}
	}
#line 150 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp12_ = midori_database_statement_get_stmt (self);
#line 150 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp13_ = _tmp12_;
#line 150 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp14_ = index;
#line 150 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp15_ = sqlite3_column_double (_tmp13_, _tmp14_);
#line 150 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = _tmp15_;
#line 150 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 1328 "midori-database.c"
}


sqlite3_stmt* midori_database_statement_get_stmt (MidoriDatabaseStatement* self) {
	sqlite3_stmt* result;
	sqlite3_stmt* _tmp0_ = NULL;
#line 34 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = self->_stmt;
#line 34 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 1343 "midori-database.c"
}


MidoriDatabase* midori_database_statement_get_database (MidoriDatabaseStatement* self) {
	MidoriDatabase* result;
	MidoriDatabase* _tmp0_ = NULL;
#line 36 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = self->priv->_database;
#line 36 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = _tmp0_;
#line 36 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 1358 "midori-database.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 36 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return self ? g_object_ref (self) : NULL;
#line 1365 "midori-database.c"
}


void midori_database_statement_set_database (MidoriDatabaseStatement* self, MidoriDatabase* value) {
	MidoriDatabase* _tmp0_ = NULL;
	MidoriDatabase* _tmp1_ = NULL;
#line 36 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_if_fail (self != NULL);
#line 36 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = value;
#line 36 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 36 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_object_unref0 (self->priv->_database);
#line 36 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->priv->_database = _tmp1_;
#line 36 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_object_notify ((GObject *) self, "database");
#line 1384 "midori-database.c"
}


const gchar* midori_database_statement_get_query (MidoriDatabaseStatement* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 37 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = self->priv->_query;
#line 37 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = _tmp0_;
#line 37 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 1399 "midori-database.c"
}


void midori_database_statement_set_query (MidoriDatabaseStatement* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 37 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_if_fail (self != NULL);
#line 37 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = value;
#line 37 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 37 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (self->priv->_query);
#line 37 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->priv->_query = _tmp1_;
#line 37 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_object_notify ((GObject *) self, "query");
#line 1418 "midori-database.c"
}


static void midori_database_statement_class_init (MidoriDatabaseStatementClass * klass) {
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	midori_database_statement_parent_class = g_type_class_peek_parent (klass);
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_type_class_add_private (klass, sizeof (MidoriDatabaseStatementPrivate));
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	((MidoriDatabaseStatementClass *) klass)->init = midori_database_statement_real_init;
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_midori_database_statement_get_property;
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_midori_database_statement_set_property;
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	G_OBJECT_CLASS (klass)->finalize = midori_database_statement_finalize;
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_DATABASE_STATEMENT_STMT, g_param_spec_pointer ("stmt", "stmt", "stmt", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_DATABASE_STATEMENT_DATABASE, g_param_spec_object ("database", "database", "database", MIDORI_TYPE_DATABASE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_DATABASE_STATEMENT_QUERY, g_param_spec_string ("query", "query", "query", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1441 "midori-database.c"
}


static void midori_database_statement_g_initable_interface_init (GInitableIface * iface) {
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	midori_database_statement_g_initable_parent_iface = g_type_interface_peek_parent (iface);
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	iface->init = (gboolean (*)(GInitable*, GCancellable*, GError**)) midori_database_statement_init;
#line 1450 "midori-database.c"
}


static void midori_database_statement_instance_init (MidoriDatabaseStatement * self) {
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->priv = MIDORI_DATABASE_STATEMENT_GET_PRIVATE (self);
#line 35 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->_stmt = NULL;
#line 38 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->priv->last_row_id = (gint64) (-1);
#line 1461 "midori-database.c"
}


static void midori_database_statement_finalize (GObject* obj) {
	MidoriDatabaseStatement * self;
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MIDORI_TYPE_DATABASE_STATEMENT, MidoriDatabaseStatement);
#line 35 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_sqlite3_finalize0 (self->_stmt);
#line 36 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_object_unref0 (self->priv->_database);
#line 37 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (self->priv->_query);
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	G_OBJECT_CLASS (midori_database_statement_parent_class)->finalize (obj);
#line 1477 "midori-database.c"
}


GType midori_database_statement_get_type (void) {
	static volatile gsize midori_database_statement_type_id__volatile = 0;
	if (g_once_init_enter (&midori_database_statement_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MidoriDatabaseStatementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) midori_database_statement_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MidoriDatabaseStatement), 0, (GInstanceInitFunc) midori_database_statement_instance_init, NULL };
		static const GInterfaceInfo g_initable_info = { (GInterfaceInitFunc) midori_database_statement_g_initable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType midori_database_statement_type_id;
		midori_database_statement_type_id = g_type_register_static (G_TYPE_OBJECT, "MidoriDatabaseStatement", &g_define_type_info, 0);
		g_type_add_interface_static (midori_database_statement_type_id, G_TYPE_INITABLE, &g_initable_info);
		g_once_init_leave (&midori_database_statement_type_id__volatile, midori_database_statement_type_id);
	}
	return midori_database_statement_type_id__volatile;
}


static void _vala_midori_database_statement_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MidoriDatabaseStatement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MIDORI_TYPE_DATABASE_STATEMENT, MidoriDatabaseStatement);
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	switch (property_id) {
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		case MIDORI_DATABASE_STATEMENT_STMT:
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		g_value_set_pointer (value, midori_database_statement_get_stmt (self));
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		break;
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		case MIDORI_DATABASE_STATEMENT_DATABASE:
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		g_value_set_object (value, midori_database_statement_get_database (self));
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		break;
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		case MIDORI_DATABASE_STATEMENT_QUERY:
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		g_value_set_string (value, midori_database_statement_get_query (self));
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		break;
#line 1518 "midori-database.c"
		default:
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		break;
#line 1524 "midori-database.c"
	}
}


static void _vala_midori_database_statement_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MidoriDatabaseStatement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MIDORI_TYPE_DATABASE_STATEMENT, MidoriDatabaseStatement);
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	switch (property_id) {
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		case MIDORI_DATABASE_STATEMENT_DATABASE:
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		midori_database_statement_set_database (self, g_value_get_object (value));
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		break;
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		case MIDORI_DATABASE_STATEMENT_QUERY:
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		midori_database_statement_set_query (self, g_value_get_string (value));
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		break;
#line 1546 "midori-database.c"
		default:
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		break;
#line 1552 "midori-database.c"
	}
}


MidoriDatabase* midori_database_construct (GType object_type, const gchar* path, GError** error) {
	MidoriDatabase * self = NULL;
	const gchar* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
#line 174 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = path;
#line 174 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self = (MidoriDatabase*) g_object_new (object_type, "path", _tmp0_, NULL);
#line 175 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	midori_database_init (self, NULL, &_inner_error_);
#line 175 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 175 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 175 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 175 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_object_unref0 (self);
#line 175 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return NULL;
#line 1577 "midori-database.c"
		} else {
#line 175 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 175 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 175 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return NULL;
#line 1585 "midori-database.c"
		}
	}
#line 173 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return self;
#line 1590 "midori-database.c"
}


MidoriDatabase* midori_database_new (const gchar* path, GError** error) {
#line 173 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return midori_database_construct (MIDORI_TYPE_DATABASE, path, error);
#line 1597 "midori-database.c"
}


static gchar* midori_database_resolve_path (MidoriDatabase* self, const gchar* path) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
#line 178 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 179 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = path;
#line 179 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp1_ == NULL) {
#line 179 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp0_ = TRUE;
#line 1615 "midori-database.c"
	} else {
		const gchar* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
#line 179 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp2_ = path;
#line 179 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp3_ = g_str_has_prefix (_tmp2_, ":memory:");
#line 179 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp0_ = _tmp3_;
#line 1625 "midori-database.c"
	}
#line 179 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp0_) {
#line 1629 "midori-database.c"
		gchar* _tmp4_ = NULL;
#line 180 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp4_ = g_strdup (":memory:");
#line 180 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		result = _tmp4_;
#line 180 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		return result;
#line 1637 "midori-database.c"
	} else {
		const gchar* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
#line 181 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp5_ = path;
#line 181 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp6_ = g_path_is_absolute (_tmp5_);
#line 181 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (!_tmp6_) {
#line 1647 "midori-database.c"
			const gchar* _tmp7_ = NULL;
			gchar* _tmp8_ = NULL;
#line 182 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp7_ = path;
#line 182 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp8_ = midori_paths_get_config_filename_for_writing (_tmp7_);
#line 182 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			result = _tmp8_;
#line 182 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return result;
#line 1658 "midori-database.c"
		}
	}
#line 183 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp9_ = path;
#line 183 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 183 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = _tmp10_;
#line 183 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 1669 "midori-database.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 1278 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1278 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1279 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1279 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1279 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1279 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	return result;
#line 1689 "midori-database.c"
}


static void ___lambda9_ (MidoriDatabase* self, const gchar* sql, guint64 nanoseconds) {
	gchar* milliseconds = NULL;
	guint64 _tmp0_ = 0ULL;
	gchar* _tmp1_ = NULL;
	FILE* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
#line 199 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_if_fail (sql != NULL);
#line 201 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = nanoseconds;
#line 201 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = g_strdup_printf ("%" G_GUINT64_FORMAT, _tmp0_ / 1000000);
#line 201 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	milliseconds = _tmp1_;
#line 202 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp2_ = stdout;
#line 202 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp3_ = self->priv->_path;
#line 202 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp4_ = sql;
#line 202 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	fprintf (_tmp2_, "§§ %s: %s (%sms)\n", _tmp3_, _tmp4_, milliseconds);
#line 199 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (milliseconds);
#line 1718 "midori-database.c"
}


static void ____lambda9__sqlite_profile_callback (gpointer self, const gchar* sql, guint64 time) {
#line 199 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	___lambda9_ ((MidoriDatabase*) self, sql, time);
#line 1725 "midori-database.c"
}


static gint _sqlite3_exec (sqlite3* self, const gchar* sql, sqlite3_callback callback, void* callback_target, gchar** errmsg) {
	gchar* _vala_errmsg = NULL;
	gint result = 0;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	sqlite3_callback _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	const gchar* _tmp6_ = NULL;
#line 34 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
	_tmp0_ = sql;
#line 36 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
	_tmp1_ = callback;
#line 36 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
	_tmp1__target = callback_target;
#line 36 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
	_tmp3_ = sqlite3_exec (self, _tmp0_, _tmp1_, _tmp1__target, (char**) (&_tmp2_));
#line 36 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
	sqlite_errmsg = _tmp2_;
#line 36 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
	ec = _tmp3_;
#line 37 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 1758 "midori-database.c"
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
#line 38 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
		_tmp4_ = sqlite_errmsg;
#line 38 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
		_tmp5_ = g_strdup (_tmp4_);
#line 38 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
		_vala_errmsg = _tmp5_;
#line 1769 "midori-database.c"
	}
#line 40 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
	_tmp6_ = sqlite_errmsg;
#line 40 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
	sqlite3_free ((void*) _tmp6_);
#line 41 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
	result = ec;
#line 41 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
	if (errmsg) {
#line 41 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 1781 "midori-database.c"
	} else {
#line 41 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 1785 "midori-database.c"
	}
#line 41 "/usr/share/vala-0.26/vapi/sqlite3.vapi"
	return result;
#line 1789 "midori-database.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 230 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return self ? g_error_copy (self) : NULL;
#line 1796 "midori-database.c"
}


static gboolean midori_database_real_init (MidoriDatabase* self, GCancellable* cancellable, GError** error) {
	gboolean result = FALSE;
	gchar* real_path = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean exists = FALSE;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	const gchar* _tmp4_ = NULL;
	sqlite3* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	const gchar* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	gchar* token = NULL;
	gchar* _tmp14_ = NULL;
	gchar* basename = NULL;
	const gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar** parts = NULL;
	const gchar* _tmp17_ = NULL;
	gchar** _tmp18_ = NULL;
	gchar** _tmp19_ = NULL;
	gint parts_length1 = 0;
	gint _parts_size_ = 0;
	const gchar* _tmp20_ = NULL;
	gchar** _tmp21_ = NULL;
	gint _tmp21__length1 = 0;
	const gchar* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	gchar* _tmp24_ = NULL;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	sqlite3* _tmp31_ = NULL;
	sqlite3* _tmp32_ = NULL;
	gint _tmp33_ = 0;
	sqlite3* _tmp36_ = NULL;
	sqlite3* _tmp37_ = NULL;
	gint64 user_version = 0LL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp38_ = NULL;
	sqlite3* _tmp39_ = NULL;
	sqlite3_stmt* _tmp40_ = NULL;
	gint _tmp41_ = 0;
	sqlite3_stmt* _tmp49_ = NULL;
	gint _tmp50_ = 0;
	sqlite3_stmt* _tmp58_ = NULL;
	gint64 _tmp59_ = 0LL;
	gint64 _tmp60_ = 0LL;
	gboolean _tmp80_ = FALSE;
	GError * _inner_error_ = NULL;
#line 187 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = self->priv->_path;
#line 187 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = midori_database_resolve_path (self, _tmp0_);
#line 187 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	real_path = _tmp1_;
#line 188 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp2_ = real_path;
#line 188 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp3_ = access (_tmp2_, F_OK);
#line 188 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	exists = _tmp3_ == 0;
#line 190 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp4_ = real_path;
#line 190 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp6_ = sqlite3_open_v2 (_tmp4_, &_tmp5_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
#line 190 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_sqlite3_close0 (self->_db);
#line 190 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->_db = _tmp5_;
#line 190 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp6_ != SQLITE_OK) {
#line 1872 "midori-database.c"
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		GError* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp7_ = real_path;
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp8_ = g_strdup_printf ("Failed to open database %s", _tmp7_);
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp9_ = _tmp8_;
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp10_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_OPEN, _tmp9_);
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp11_ = _tmp10_;
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_tmp9_);
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = _tmp11_;
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (real_path);
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 1900 "midori-database.c"
		} else {
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (real_path);
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 191 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 1910 "midori-database.c"
		}
	}
#line 193 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp13_ = g_getenv ("MIDORI_DEBUG");
#line 193 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp12_ = _tmp13_;
#line 193 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp12_ == NULL) {
#line 193 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp12_ = "";
#line 1921 "midori-database.c"
	}
#line 193 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp14_ = g_strdup (_tmp12_);
#line 193 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	token = _tmp14_;
#line 194 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp15_ = self->priv->_path;
#line 194 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp16_ = g_path_get_basename (_tmp15_);
#line 194 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	basename = _tmp16_;
#line 195 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp17_ = basename;
#line 195 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp19_ = _tmp18_ = g_strsplit (_tmp17_, ".", 0);
#line 195 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	parts = _tmp19_;
#line 195 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	parts_length1 = _vala_array_length (_tmp18_);
#line 195 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_parts_size_ = parts_length1;
#line 196 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp20_ = token;
#line 196 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp21_ = parts;
#line 196 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp21__length1 = parts_length1;
#line 196 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp22_ = _tmp21_[0];
#line 196 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp23_ = g_strconcat ("db:", _tmp22_, NULL);
#line 196 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp24_ = _tmp23_;
#line 196 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp25_ = string_contains (_tmp20_, _tmp24_);
#line 196 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->trace = _tmp25_;
#line 196 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (_tmp24_);
#line 197 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp26_ = self->trace;
#line 197 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp26_) {
#line 1965 "midori-database.c"
		FILE* _tmp27_ = NULL;
		const gchar* _tmp28_ = NULL;
		sqlite3* _tmp29_ = NULL;
		sqlite3* _tmp30_ = NULL;
#line 198 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp27_ = stdout;
#line 198 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp28_ = self->priv->_path;
#line 198 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		fprintf (_tmp27_, "§§ Tracing %s\n", _tmp28_);
#line 199 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp29_ = midori_database_get_db (self);
#line 199 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp30_ = _tmp29_;
#line 199 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		sqlite3_profile (_tmp30_, ____lambda9__sqlite_profile_callback, self);
#line 1982 "midori-database.c"
	}
#line 206 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp31_ = midori_database_get_db (self);
#line 206 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp32_ = _tmp31_;
#line 206 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp33_ = _sqlite3_exec (_tmp32_, "PRAGMA journal_mode = WAL; PRAGMA cache_size = 32100;", NULL, NULL, NULL);
#line 206 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp33_ != SQLITE_OK) {
#line 1992 "midori-database.c"
		sqlite3* _tmp34_ = NULL;
		sqlite3* _tmp35_ = NULL;
#line 207 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp34_ = midori_database_get_db (self);
#line 207 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp35_ = _tmp34_;
#line 207 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_sqlite3_exec (_tmp35_, "PRAGMA synchronous = NORMAL; PRAGMA temp_store = MEMORY;", NULL, NULL, NULL);
#line 2001 "midori-database.c"
	}
#line 208 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp36_ = midori_database_get_db (self);
#line 208 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp37_ = _tmp36_;
#line 208 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_sqlite3_exec (_tmp37_, "PRAGMA count_changes = OFF;", NULL, NULL, NULL);
#line 212 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp38_ = midori_database_get_db (self);
#line 212 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp39_ = _tmp38_;
#line 212 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp41_ = sqlite3_prepare_v2 (_tmp39_, "PRAGMA user_version;", -1, &_tmp40_, NULL);
#line 212 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_sqlite3_finalize0 (stmt);
#line 212 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	stmt = _tmp40_;
#line 212 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp41_ != SQLITE_OK) {
#line 2021 "midori-database.c"
		sqlite3* _tmp42_ = NULL;
		sqlite3* _tmp43_ = NULL;
		const gchar* _tmp44_ = NULL;
		gchar* _tmp45_ = NULL;
		gchar* _tmp46_ = NULL;
		GError* _tmp47_ = NULL;
		GError* _tmp48_ = NULL;
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp42_ = midori_database_get_db (self);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp43_ = _tmp42_;
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp44_ = sqlite3_errmsg (_tmp43_);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp45_ = g_strdup_printf ("Failed to compile statement %s", _tmp44_);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp46_ = _tmp45_;
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp47_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, _tmp46_);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp48_ = _tmp47_;
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_tmp46_);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = _tmp48_;
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_sqlite3_finalize0 (stmt);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (basename);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (token);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (real_path);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2063 "midori-database.c"
		} else {
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_sqlite3_finalize0 (stmt);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (basename);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (token);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (real_path);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 213 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2081 "midori-database.c"
		}
	}
#line 214 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp49_ = stmt;
#line 214 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp50_ = sqlite3_step (_tmp49_);
#line 214 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp50_ != SQLITE_ROW) {
#line 2090 "midori-database.c"
		sqlite3* _tmp51_ = NULL;
		sqlite3* _tmp52_ = NULL;
		const gchar* _tmp53_ = NULL;
		gchar* _tmp54_ = NULL;
		gchar* _tmp55_ = NULL;
		GError* _tmp56_ = NULL;
		GError* _tmp57_ = NULL;
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp51_ = midori_database_get_db (self);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp52_ = _tmp51_;
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp53_ = sqlite3_errmsg (_tmp52_);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp54_ = g_strdup_printf ("Failed to get row %s", _tmp53_);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp55_ = _tmp54_;
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp56_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, _tmp55_);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp57_ = _tmp56_;
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_tmp55_);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = _tmp57_;
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_sqlite3_finalize0 (stmt);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (basename);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (token);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (real_path);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2132 "midori-database.c"
		} else {
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_sqlite3_finalize0 (stmt);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (basename);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (token);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (real_path);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 215 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2150 "midori-database.c"
		}
	}
#line 216 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp58_ = stmt;
#line 216 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp59_ = sqlite3_column_int64 (_tmp58_, 0);
#line 216 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	user_version = _tmp59_;
#line 218 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp60_ = user_version;
#line 218 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp60_ == ((gint64) 0)) {
#line 2163 "midori-database.c"
		gint64 _tmp61_ = 0LL;
		gchar* _tmp62_ = NULL;
		gchar* _tmp63_ = NULL;
		gchar* _tmp64_ = NULL;
		gchar* _tmp65_ = NULL;
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		midori_database_exec_script (self, "Create", &_inner_error_);
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				g_propagate_error (error, _inner_error_);
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (basename);
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (token);
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (real_path);
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				return FALSE;
#line 2189 "midori-database.c"
			} else {
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (basename);
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (token);
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (real_path);
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				g_clear_error (&_inner_error_);
#line 219 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				return FALSE;
#line 2207 "midori-database.c"
			}
		}
#line 220 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		user_version = (gint64) 1;
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp61_ = user_version;
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp62_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp61_);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp63_ = _tmp62_;
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp64_ = g_strconcat ("PRAGMA user_version = ", _tmp63_, NULL);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp65_ = _tmp64_;
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		midori_database_exec (self, _tmp65_, &_inner_error_);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_tmp65_);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_tmp63_);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				g_propagate_error (error, _inner_error_);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (basename);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (token);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (real_path);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				return FALSE;
#line 2246 "midori-database.c"
			} else {
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (basename);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (token);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (real_path);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				g_clear_error (&_inner_error_);
#line 221 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				return FALSE;
#line 2264 "midori-database.c"
			}
		}
	}
#line 224 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	while (TRUE) {
#line 2270 "midori-database.c"
		gint64 _tmp74_ = 0LL;
		gint64 _tmp75_ = 0LL;
		gchar* _tmp76_ = NULL;
		gchar* _tmp77_ = NULL;
		gchar* _tmp78_ = NULL;
		gchar* _tmp79_ = NULL;
		{
			gint64 _tmp66_ = 0LL;
			gchar* _tmp67_ = NULL;
			gchar* _tmp68_ = NULL;
			gchar* _tmp69_ = NULL;
			gchar* _tmp70_ = NULL;
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp66_ = user_version;
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp67_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp66_);
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp68_ = _tmp67_;
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp69_ = g_strconcat ("Update", _tmp68_, NULL);
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp70_ = _tmp69_;
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			midori_database_exec_script (self, _tmp70_, &_inner_error_);
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (_tmp70_);
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (_tmp68_);
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 2303 "midori-database.c"
					goto __catch23_midori_database_error;
				}
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (basename);
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (token);
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (real_path);
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				g_clear_error (&_inner_error_);
#line 226 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				return FALSE;
#line 2322 "midori-database.c"
			}
		}
		goto __finally23;
		__catch23_midori_database_error:
		{
			GError* _error_ = NULL;
			GError* _tmp71_ = NULL;
			GError* _tmp72_ = NULL;
			GError* _tmp73_ = NULL;
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_error_ = _inner_error_;
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_inner_error_ = NULL;
#line 228 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp71_ = _error_;
#line 228 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			if (g_error_matches (_tmp71_, MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_FILENAME)) {
#line 229 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_error_free0 (_error_);
#line 229 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				break;
#line 2344 "midori-database.c"
			}
#line 230 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp72_ = _error_;
#line 230 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp73_ = _g_error_copy0 (_tmp72_);
#line 230 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_inner_error_ = _tmp73_;
#line 230 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_error_free0 (_error_);
#line 2354 "midori-database.c"
			goto __finally23;
		}
		__finally23:
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				g_propagate_error (error, _inner_error_);
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (basename);
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (token);
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (real_path);
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				return FALSE;
#line 2376 "midori-database.c"
			} else {
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (basename);
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (token);
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (real_path);
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				g_clear_error (&_inner_error_);
#line 225 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				return FALSE;
#line 2394 "midori-database.c"
			}
		}
#line 232 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp74_ = user_version;
#line 232 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		user_version = _tmp74_ + 1;
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp75_ = user_version;
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp76_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp75_);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp77_ = _tmp76_;
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp78_ = g_strconcat ("PRAGMA user_version = ", _tmp77_, NULL);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp79_ = _tmp78_;
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		midori_database_exec (self, _tmp79_, &_inner_error_);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_tmp79_);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_tmp77_);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				g_propagate_error (error, _inner_error_);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (basename);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (token);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (real_path);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				return FALSE;
#line 2435 "midori-database.c"
			} else {
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_sqlite3_finalize0 (stmt);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (basename);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (token);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_g_free0 (real_path);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				g_clear_error (&_inner_error_);
#line 233 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				return FALSE;
#line 2453 "midori-database.c"
			}
		}
	}
#line 236 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp80_ = exists;
#line 236 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	midori_database_set_first_use (self, !_tmp80_);
#line 237 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = TRUE;
#line 237 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_sqlite3_finalize0 (stmt);
#line 237 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 237 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (basename);
#line 237 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (token);
#line 237 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (real_path);
#line 237 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 2475 "midori-database.c"
}


gboolean midori_database_init (MidoriDatabase* self, GCancellable* cancellable, GError** error) {
#line 186 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 186 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return MIDORI_DATABASE_GET_CLASS (self)->init (self, cancellable, error);
#line 2484 "midori-database.c"
}


gboolean midori_database_attach (MidoriDatabase* self, const gchar* path, const gchar* alias, GError** error) {
	gboolean result = FALSE;
	gchar* real_path = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean exists = FALSE;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	GError * _inner_error_ = NULL;
#line 243 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 243 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 243 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (alias != NULL, FALSE);
#line 244 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = path;
#line 244 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = midori_database_resolve_path (self, _tmp0_);
#line 244 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	real_path = _tmp1_;
#line 245 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp2_ = real_path;
#line 245 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp3_ = access (_tmp2_, F_OK);
#line 245 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	exists = _tmp3_ == 0;
#line 246 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp4_ = exists;
#line 246 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (!_tmp4_) {
#line 2527 "midori-database.c"
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
		GError* _tmp9_ = NULL;
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp5_ = path;
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp6_ = g_strdup_printf ("Failed to attach database %s", _tmp5_);
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp7_ = _tmp6_;
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp8_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_OPEN, _tmp7_);
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp9_ = _tmp8_;
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_tmp7_);
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = _tmp9_;
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (real_path);
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2555 "midori-database.c"
		} else {
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (real_path);
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 247 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2565 "midori-database.c"
		}
	}
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp11_ = real_path;
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp12_ = alias;
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp13_ = g_strdup_printf ("ATTACH DATABASE '%s' AS '%s';", _tmp11_, _tmp12_);
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp14_ = _tmp13_;
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp15_ = midori_database_exec (self, _tmp14_, &_inner_error_);
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp16_ = _tmp15_;
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (_tmp14_);
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp10_ = _tmp16_;
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (real_path);
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2594 "midori-database.c"
		} else {
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (real_path);
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2604 "midori-database.c"
		}
	}
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = _tmp10_;
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (real_path);
#line 248 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 2613 "midori-database.c"
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
#line 251 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 251 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return _data2_;
#line 2622 "midori-database.c"
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 251 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 2631 "midori-database.c"
		MidoriDatabase* self;
#line 251 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		self = _data2_->self;
#line 251 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_data2_->schema);
#line 251 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_object_unref0 (self);
#line 251 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		g_slice_free (Block2Data, _data2_);
#line 2641 "midori-database.c"
	}
}


static gboolean __lambda10_ (Block2Data* _data2_, GError** error) {
	MidoriDatabase* self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GError * _inner_error_ = NULL;
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self = _data2_->self;
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = _data2_->schema;
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp2_ = midori_database_exec (self, _tmp1_, &_inner_error_);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = _tmp2_;
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2669 "midori-database.c"
		} else {
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2677 "midori-database.c"
		}
	}
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = _tmp0_;
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 2684 "midori-database.c"
}


static gboolean ___lambda10__midori_database_callback (gpointer self, GError** error) {
	gboolean result;
	result = __lambda10_ (self, error);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 2693 "midori-database.c"
}


gboolean midori_database_exec_script (MidoriDatabase* self, const gchar* filename, GError** error) {
	gboolean result = FALSE;
	Block2Data* _data2_;
	gchar* basename = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar** parts = NULL;
	const gchar* _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gchar** _tmp4_ = NULL;
	gint parts_length1 = 0;
	gint _parts_size_ = 0;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar** _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	gchar* schema_filename = NULL;
	gchar** _tmp17_ = NULL;
	gint _tmp17__length1 = 0;
	const gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	const gchar* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	gchar* _tmp24_ = NULL;
	gchar* _tmp25_ = NULL;
	gchar* _tmp26_ = NULL;
	gchar* _tmp27_ = NULL;
	GError * _inner_error_ = NULL;
#line 251 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 251 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 251 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 251 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_data2_->_ref_count_ = 1;
#line 251 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_data2_->self = g_object_ref (self);
#line 252 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = self->priv->_path;
#line 252 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = g_path_get_basename (_tmp0_);
#line 252 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	basename = _tmp1_;
#line 253 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp2_ = basename;
#line 253 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, ".", 0);
#line 253 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	parts = _tmp4_;
#line 253 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	parts_length1 = _vala_array_length (_tmp3_);
#line 253 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_parts_size_ = parts_length1;
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp7_ = parts;
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp7__length1 = parts_length1;
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp7_ != NULL) {
#line 2759 "midori-database.c"
		gchar** _tmp8_ = NULL;
		gint _tmp8__length1 = 0;
		const gchar* _tmp9_ = NULL;
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp8_ = parts;
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp8__length1 = parts_length1;
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp9_ = _tmp8_[0];
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp6_ = _tmp9_ != NULL;
#line 2771 "midori-database.c"
	} else {
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp6_ = FALSE;
#line 2775 "midori-database.c"
	}
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp6_) {
#line 2779 "midori-database.c"
		gchar** _tmp10_ = NULL;
		gint _tmp10__length1 = 0;
		const gchar* _tmp11_ = NULL;
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp10_ = parts;
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp10__length1 = parts_length1;
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp11_ = _tmp10_[1];
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp5_ = _tmp11_ != NULL;
#line 2791 "midori-database.c"
	} else {
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp5_ = FALSE;
#line 2795 "midori-database.c"
	}
#line 254 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (!_tmp5_) {
#line 2799 "midori-database.c"
		const gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		GError* _tmp15_ = NULL;
		GError* _tmp16_ = NULL;
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp12_ = self->priv->_path;
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp13_ = g_strdup_printf ("Failed to deduce schema filename from %s", _tmp12_);
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp14_ = _tmp13_;
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp15_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_NAMING, _tmp14_);
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp16_ = _tmp15_;
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_tmp14_);
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = _tmp16_;
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (basename);
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			block2_data_unref (_data2_);
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_data2_ = NULL;
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2833 "midori-database.c"
		} else {
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (basename);
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			block2_data_unref (_data2_);
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_data2_ = NULL;
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 255 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2849 "midori-database.c"
		}
	}
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp17_ = parts;
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp17__length1 = parts_length1;
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp18_ = _tmp17_[0];
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp19_ = g_strconcat (_tmp18_, "/", NULL);
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp20_ = _tmp19_;
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp21_ = filename;
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp22_ = g_strconcat (_tmp20_, _tmp21_, NULL);
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp23_ = _tmp22_;
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp24_ = g_strconcat (_tmp23_, ".sql", NULL);
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp25_ = _tmp24_;
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp26_ = midori_paths_get_res_filename (_tmp25_);
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp27_ = _tmp26_;
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (_tmp25_);
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (_tmp23_);
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (_tmp20_);
#line 256 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	schema_filename = _tmp27_;
#line 2884 "midori-database.c"
	{
		const gchar* _tmp28_ = NULL;
		gchar* _tmp29_ = NULL;
#line 259 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp28_ = schema_filename;
#line 259 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		g_file_get_contents (_tmp28_, &_tmp29_, NULL, &_inner_error_);
#line 259 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_data2_->schema);
#line 259 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_data2_->schema = _tmp29_;
#line 259 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2898 "midori-database.c"
			goto __catch24_g_error;
		}
	}
	goto __finally24;
	__catch24_g_error:
	{
		GError* _error_ = NULL;
		const gchar* _tmp30_ = NULL;
		gchar* _tmp31_ = NULL;
		gchar* _tmp32_ = NULL;
		GError* _tmp33_ = NULL;
		GError* _tmp34_ = NULL;
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_error_ = _inner_error_;
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = NULL;
#line 261 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp30_ = schema_filename;
#line 261 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp31_ = g_strdup_printf ("Failed to open schema: %s", _tmp30_);
#line 261 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp32_ = _tmp31_;
#line 261 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp33_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_FILENAME, _tmp32_);
#line 261 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp34_ = _tmp33_;
#line 261 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_free0 (_tmp32_);
#line 261 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = _tmp34_;
#line 261 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_g_error_free0 (_error_);
#line 2931 "midori-database.c"
		goto __finally24;
	}
	__finally24:
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (schema_filename);
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (basename);
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			block2_data_unref (_data2_);
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_data2_ = NULL;
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2953 "midori-database.c"
		} else {
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (schema_filename);
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (basename);
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			block2_data_unref (_data2_);
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_data2_ = NULL;
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 258 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2971 "midori-database.c"
		}
	}
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	midori_database_transaction (self, ___lambda10__midori_database_callback, _data2_, &_inner_error_);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (schema_filename);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (basename);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			block2_data_unref (_data2_);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_data2_ = NULL;
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 2994 "midori-database.c"
		} else {
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (schema_filename);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (basename);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			block2_data_unref (_data2_);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_data2_ = NULL;
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 263 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 3012 "midori-database.c"
		}
	}
#line 264 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = TRUE;
#line 264 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (schema_filename);
#line 264 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 264 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (basename);
#line 264 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	block2_data_unref (_data2_);
#line 264 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_data2_ = NULL;
#line 264 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 3029 "midori-database.c"
}


gboolean midori_database_transaction (MidoriDatabase* self, MidoriDatabaseCallback callback, void* callback_target, GError** error) {
	gboolean result = FALSE;
	MidoriDatabaseCallback _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	GError * _inner_error_ = NULL;
#line 267 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 268 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	midori_database_exec (self, "BEGIN TRANSACTION;", &_inner_error_);
#line 268 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 268 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 268 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 268 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 3050 "midori-database.c"
		} else {
#line 268 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 268 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 268 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 3058 "midori-database.c"
		}
	}
#line 269 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = callback;
#line 269 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0__target = callback_target;
#line 269 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ (_tmp0__target, &_inner_error_);
#line 269 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 269 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 269 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 269 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 3075 "midori-database.c"
		} else {
#line 269 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 269 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 269 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 3083 "midori-database.c"
		}
	}
#line 270 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	midori_database_exec (self, "COMMIT;", &_inner_error_);
#line 270 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 270 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 270 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 270 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 3096 "midori-database.c"
		} else {
#line 270 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 270 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 270 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 3104 "midori-database.c"
		}
	}
#line 271 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = TRUE;
#line 271 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 3111 "midori-database.c"
}


gboolean midori_database_exec (MidoriDatabase* self, const gchar* query, GError** error) {
	gboolean result = FALSE;
	sqlite3* _tmp0_ = NULL;
	sqlite3* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	GError * _inner_error_ = NULL;
#line 274 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 274 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (query != NULL, FALSE);
#line 275 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = midori_database_get_db (self);
#line 275 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = _tmp0_;
#line 275 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp2_ = query;
#line 275 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp3_ = _sqlite3_exec (_tmp1_, _tmp2_, NULL, NULL, NULL);
#line 275 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp3_ != SQLITE_OK) {
#line 3136 "midori-database.c"
		sqlite3* _tmp4_ = NULL;
		sqlite3* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		GError* _tmp7_ = NULL;
#line 276 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp4_ = midori_database_get_db (self);
#line 276 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp5_ = _tmp4_;
#line 276 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp6_ = sqlite3_errmsg (_tmp5_);
#line 276 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp7_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_EXECUTE, _tmp6_);
#line 276 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_inner_error_ = _tmp7_;
#line 276 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 276 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 276 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 3157 "midori-database.c"
		} else {
#line 276 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 276 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 276 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return FALSE;
#line 3165 "midori-database.c"
		}
	}
#line 277 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = TRUE;
#line 277 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 3172 "midori-database.c"
}


MidoriDatabaseStatement* midori_database_prepare (MidoriDatabase* self, const gchar* query, GError** error, ...) {
	MidoriDatabaseStatement* result = NULL;
	MidoriDatabaseStatement* statement = NULL;
	const gchar* _tmp0_ = NULL;
	MidoriDatabaseStatement* _tmp1_ = NULL;
	va_list args = {0};
	const gchar* pname = NULL;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp32_ = FALSE;
	GError * _inner_error_ = NULL;
#line 285 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 285 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (query != NULL, NULL);
#line 286 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = query;
#line 286 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = midori_database_statement_new (self, _tmp0_, &_inner_error_);
#line 286 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	statement = _tmp1_;
#line 286 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 286 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 286 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_propagate_error (error, _inner_error_);
#line 286 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return NULL;
#line 3204 "midori-database.c"
		} else {
#line 286 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 286 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			g_clear_error (&_inner_error_);
#line 286 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			return NULL;
#line 3212 "midori-database.c"
		}
	}
#line 287 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	va_start (args, error);
#line 288 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp2_ = va_arg (args, gchar*);
#line 288 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	pname = _tmp2_;
#line 289 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	while (TRUE) {
#line 3223 "midori-database.c"
		const gchar* _tmp3_ = NULL;
		GType ptype = 0UL;
		GType _tmp4_ = 0UL;
		GType _tmp5_ = 0UL;
		const gchar* _tmp31_ = NULL;
#line 289 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp3_ = pname;
#line 289 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (!(_tmp3_ != NULL)) {
#line 289 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			break;
#line 3235 "midori-database.c"
		}
#line 290 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp4_ = va_arg (args, GType);
#line 290 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		ptype = _tmp4_;
#line 291 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp5_ = ptype;
#line 291 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		if (_tmp5_ == G_TYPE_STRING) {
#line 3245 "midori-database.c"
			gchar* pvalue = NULL;
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			MidoriDatabaseStatement* _tmp8_ = NULL;
			const gchar* _tmp9_ = NULL;
			GType _tmp10_ = 0UL;
			const gchar* _tmp11_ = NULL;
#line 292 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp6_ = va_arg (args, gchar*);
#line 292 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp7_ = g_strdup (_tmp6_);
#line 292 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			pvalue = _tmp7_;
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp8_ = statement;
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp9_ = pname;
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp10_ = ptype;
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp11_ = pvalue;
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			midori_database_statement_bind (_tmp8_, _tmp9_, &_inner_error_, _tmp10_, _tmp11_, NULL);
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					g_propagate_error (error, _inner_error_);
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_g_free0 (pvalue);
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					va_end (args);
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_g_object_unref0 (statement);
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					return NULL;
#line 3283 "midori-database.c"
				} else {
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_g_free0 (pvalue);
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					va_end (args);
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_g_object_unref0 (statement);
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					g_clear_error (&_inner_error_);
#line 293 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					return NULL;
#line 3297 "midori-database.c"
				}
			}
#line 291 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_g_free0 (pvalue);
#line 3302 "midori-database.c"
		} else {
			GType _tmp12_ = 0UL;
#line 294 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			_tmp12_ = ptype;
#line 294 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
			if (_tmp12_ == G_TYPE_INT64) {
#line 3309 "midori-database.c"
				gint64 pvalue = 0LL;
				gint64 _tmp13_ = 0LL;
				MidoriDatabaseStatement* _tmp14_ = NULL;
				const gchar* _tmp15_ = NULL;
				GType _tmp16_ = 0UL;
				gint64 _tmp17_ = 0LL;
#line 295 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp13_ = va_arg (args, gint64);
#line 295 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				pvalue = _tmp13_;
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp14_ = statement;
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp15_ = pname;
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp16_ = ptype;
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp17_ = pvalue;
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				midori_database_statement_bind (_tmp14_, _tmp15_, &_inner_error_, _tmp16_, _tmp17_, NULL);
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						g_propagate_error (error, _inner_error_);
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						va_end (args);
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						_g_object_unref0 (statement);
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						return NULL;
#line 3342 "midori-database.c"
					} else {
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						va_end (args);
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						_g_object_unref0 (statement);
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						g_clear_error (&_inner_error_);
#line 296 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						return NULL;
#line 3354 "midori-database.c"
					}
				}
			} else {
				GType _tmp18_ = 0UL;
#line 297 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				_tmp18_ = ptype;
#line 297 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
				if (_tmp18_ == G_TYPE_DOUBLE) {
#line 3363 "midori-database.c"
					gdouble pvalue = 0.0;
					gdouble _tmp19_ = 0.0;
					MidoriDatabaseStatement* _tmp20_ = NULL;
					const gchar* _tmp21_ = NULL;
					GType _tmp22_ = 0UL;
					gdouble _tmp23_ = 0.0;
#line 298 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp19_ = va_arg (args, gdouble);
#line 298 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					pvalue = _tmp19_;
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp20_ = statement;
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp21_ = pname;
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp22_ = ptype;
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp23_ = pvalue;
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					midori_database_statement_bind (_tmp20_, _tmp21_, &_inner_error_, _tmp22_, _tmp23_, NULL);
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
							g_propagate_error (error, _inner_error_);
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
							va_end (args);
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
							_g_object_unref0 (statement);
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
							return NULL;
#line 3396 "midori-database.c"
						} else {
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
							va_end (args);
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
							_g_object_unref0 (statement);
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
							g_clear_error (&_inner_error_);
#line 299 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
							return NULL;
#line 3408 "midori-database.c"
						}
					}
				} else {
					GType _tmp24_ = 0UL;
					const gchar* _tmp25_ = NULL;
					const gchar* _tmp26_ = NULL;
					gchar* _tmp27_ = NULL;
					gchar* _tmp28_ = NULL;
					GError* _tmp29_ = NULL;
					GError* _tmp30_ = NULL;
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp24_ = ptype;
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp25_ = g_type_name (_tmp24_);
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp26_ = query;
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp27_ = g_strdup_printf ("Invalid type '%s' in statement: %s", _tmp25_, _tmp26_);
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp28_ = _tmp27_;
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp29_ = g_error_new_literal (MIDORI_DATABASE_ERROR, MIDORI_DATABASE_ERROR_TYPE, _tmp28_);
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_tmp30_ = _tmp29_;
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_g_free0 (_tmp28_);
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					_inner_error_ = _tmp30_;
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
					if (_inner_error_->domain == MIDORI_DATABASE_ERROR) {
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						g_propagate_error (error, _inner_error_);
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						va_end (args);
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						_g_object_unref0 (statement);
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						return NULL;
#line 3447 "midori-database.c"
					} else {
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						va_end (args);
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						_g_object_unref0 (statement);
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						g_clear_error (&_inner_error_);
#line 301 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
						return NULL;
#line 3459 "midori-database.c"
					}
				}
			}
		}
#line 302 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp31_ = va_arg (args, gchar*);
#line 302 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		pname = _tmp31_;
#line 3468 "midori-database.c"
	}
#line 304 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp32_ = self->trace;
#line 304 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	if (_tmp32_) {
#line 3474 "midori-database.c"
		FILE* _tmp33_ = NULL;
#line 305 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		_tmp33_ = stdout;
#line 305 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		fprintf (_tmp33_, "\n");
#line 3480 "midori-database.c"
	}
#line 306 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = statement;
#line 306 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	va_end (args);
#line 306 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 3488 "midori-database.c"
}


sqlite3* midori_database_get_db (MidoriDatabase* self) {
	sqlite3* result;
	sqlite3* _tmp0_ = NULL;
#line 159 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 159 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = self->_db;
#line 159 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = _tmp0_;
#line 159 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 3503 "midori-database.c"
}


const gchar* midori_database_get_path (MidoriDatabase* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 161 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 161 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = self->priv->_path;
#line 161 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = _tmp0_;
#line 161 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 3518 "midori-database.c"
}


void midori_database_set_path (MidoriDatabase* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 161 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_if_fail (self != NULL);
#line 161 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = value;
#line 161 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 161 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (self->priv->_path);
#line 161 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->priv->_path = _tmp1_;
#line 161 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_object_notify ((GObject *) self, "path");
#line 3537 "midori-database.c"
}


gboolean midori_database_get_first_use (MidoriDatabase* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 167 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 167 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = self->priv->_first_use;
#line 167 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	result = _tmp0_;
#line 167 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	return result;
#line 3552 "midori-database.c"
}


void midori_database_set_first_use (MidoriDatabase* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 167 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_return_if_fail (self != NULL);
#line 167 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_tmp0_ = value;
#line 167 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->priv->_first_use = _tmp0_;
#line 167 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_object_notify ((GObject *) self, "first-use");
#line 3566 "midori-database.c"
}


static void midori_database_class_init (MidoriDatabaseClass * klass) {
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	midori_database_parent_class = g_type_class_peek_parent (klass);
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_type_class_add_private (klass, sizeof (MidoriDatabasePrivate));
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	((MidoriDatabaseClass *) klass)->init = midori_database_real_init;
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_midori_database_get_property;
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_midori_database_set_property;
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	G_OBJECT_CLASS (klass)->finalize = midori_database_finalize;
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_DATABASE_DB, g_param_spec_pointer ("db", "db", "db", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_DATABASE_PATH, g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_DATABASE_FIRST_USE, g_param_spec_boolean ("first-use", "first-use", "first-use", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3589 "midori-database.c"
}


static void midori_database_g_initable_interface_init (GInitableIface * iface) {
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	midori_database_g_initable_parent_iface = g_type_interface_peek_parent (iface);
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	iface->init = (gboolean (*)(GInitable*, GCancellable*, GError**)) midori_database_init;
#line 3598 "midori-database.c"
}


static void midori_database_instance_init (MidoriDatabase * self) {
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->priv = MIDORI_DATABASE_GET_PRIVATE (self);
#line 158 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->trace = FALSE;
#line 160 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->_db = NULL;
#line 161 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->priv->_path = NULL;
#line 167 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self->priv->_first_use = FALSE;
#line 3613 "midori-database.c"
}


static void midori_database_finalize (GObject* obj) {
	MidoriDatabase * self;
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MIDORI_TYPE_DATABASE, MidoriDatabase);
#line 160 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_sqlite3_close0 (self->_db);
#line 161 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	_g_free0 (self->priv->_path);
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	G_OBJECT_CLASS (midori_database_parent_class)->finalize (obj);
#line 3627 "midori-database.c"
}


GType midori_database_get_type (void) {
	static volatile gsize midori_database_type_id__volatile = 0;
	if (g_once_init_enter (&midori_database_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MidoriDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) midori_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MidoriDatabase), 0, (GInstanceInitFunc) midori_database_instance_init, NULL };
		static const GInterfaceInfo g_initable_info = { (GInterfaceInitFunc) midori_database_g_initable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType midori_database_type_id;
		midori_database_type_id = g_type_register_static (G_TYPE_OBJECT, "MidoriDatabase", &g_define_type_info, 0);
		g_type_add_interface_static (midori_database_type_id, G_TYPE_INITABLE, &g_initable_info);
		g_once_init_leave (&midori_database_type_id__volatile, midori_database_type_id);
	}
	return midori_database_type_id__volatile;
}


static void _vala_midori_database_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MidoriDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MIDORI_TYPE_DATABASE, MidoriDatabase);
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	switch (property_id) {
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		case MIDORI_DATABASE_DB:
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		g_value_set_pointer (value, midori_database_get_db (self));
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		break;
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		case MIDORI_DATABASE_PATH:
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		g_value_set_string (value, midori_database_get_path (self));
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		break;
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		case MIDORI_DATABASE_FIRST_USE:
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		g_value_set_boolean (value, midori_database_get_first_use (self));
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		break;
#line 3668 "midori-database.c"
		default:
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		break;
#line 3674 "midori-database.c"
	}
}


static void _vala_midori_database_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MidoriDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MIDORI_TYPE_DATABASE, MidoriDatabase);
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
	switch (property_id) {
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		case MIDORI_DATABASE_PATH:
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		midori_database_set_path (self, g_value_get_string (value));
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		break;
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		case MIDORI_DATABASE_FIRST_USE:
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		midori_database_set_first_use (self, g_value_get_boolean (value));
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		break;
#line 3696 "midori-database.c"
		default:
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 157 "/builddir/build/BUILD/midori-0.5.9/midori/midori-database.vala"
		break;
#line 3702 "midori-database.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



